<?php
//start session and set cookie parameters
ini_set('session.cookie_lifetime', 86400);
ini_set('session.gc_maxlifetime', 86400);
@session_set_cookie_params(86400, '/');
@session_start();

//debug data
$queryCount = 0;
$queryCountCached = 0;
$_mtime = explode(" ", microtime());
$_starttime = $_mtime[1] + $_mtime[0];

//check CSRF token
if($_POST['mbauthtoken']) { $_POST['mbAuthToken'] = $_POST['mbauthtoken']; } //fix for ajax calls making variable name lower case...
if($_POST && $_SESSION['mbAuthToken'] && stripos($_SERVER['REQUEST_URI'],'admin/') !== false && php_sapi_name != 'cli') { 
	if($_POST['mbAuthToken'] != $_SESSION['mbAuthToken']) { 
		header("HTTP/1.1 401 Unauthorized");
		exit("HTTP/1.1 401 Unauthorized P $_POST[mbAuthToken] S $_SESSION[mbAuthToken]");
	}
}

//prevent iframing the admin area from other domains.
if(stripos($_SERVER['REQUEST_URI'],'admin/') !== false) { 
	header('X-Frame-Options: SAMEORIGIN');
}
header("X-XSS-Protection: 1");
header('X-Content-Type-Options: nosniff');
header('content-type:text/html;charset=utf-8');
mb_regex_encoding('UTF-8');
mb_internal_encoding('UTF-8');

include('config.php');

if ($config['development_mode_admin_only'] && !isset($_SESSION['isAdmin'])) {
    $config['development_mode'] = 0;
}

if ($config['development_mode']) {
    error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED & ~E_WARNING);
    ini_set('display_errors', 1);
}

@include('adultCentro.config.php');
@include('webmasterCentral.config.php');

include($basepath . "/admin/functions.mb.php"); //core functions
mysqli_set_charset($dblink,'utf8');

/* get language from subdomain */
$language = $config['default_language'];
if ($config['default_language'] != $config['core_language']) {
    $language = $currentLang = $config['default_language'];
}
$subdomain = explode(".", $_SERVER['HTTP_HOST']);
if ($subdomain[0] != 'www' && strlen($subdomain[0]) == 2 && count($subdomain) > 2) {
    @$validLanguages = json_decode(file_get_contents($basepath . '/admin/scripts/validLanguages.json', true));
    if ((is_array($validLanguages) && in_array(strtoupper($subdomain[0]), $validLanguages)) || ($config['core_language'] != $config['default_language'] && strtoupper($subdomain[0]) === $config['core_language'])) {
        $language = $currentLang = strtoupper($subdomain[0]);
    }
}
/* EOF */

include($basepath . "/admin/functions.hashing.php"); //url hashing functions
include($basepath . "/admin/functions.licensing.php"); //license functions
include($basepath . "/admin/functions.general.php"); //general functions 
include($basepath . "/admin/functions.templating.php"); //template functions 
include($basepath . "/admin/functions.multilang.php"); //bug fix functions, never edit this file.
include($basepath . "/admin/functions.player.php"); //player functions 
include($basepath . "/admin/functions.email.php"); //email system functions
include($basepath . "/admin/functions.thumbnailing.php"); //thumbnailing functions
include($basepath . "/admin/functions.bugfix.php"); //bug fix functions, never edit this file.
include($basepath . "/admin/functions.bootstrap.php"); //altered connection functions
include($basepath . "/admin/functions.billing.php"); //altered connection functions
include($basepath . "/admin/functions.modules.php"); //modules functions
include($basepath . "/admin/functions.cdn.php"); //altered connection functions
include($basepath . "/admin/functions.ceph.php"); //modules functions
include($basepath . "/admin/functions.awempire.php"); //modules functions
modulesInclude();
header_remove("Expires");

if (modulesCheck('paysite') && function_exists('paysiteGetConfig')) {
    $mod['paysite'] = paysiteGetConfig();
    if ($mod['paysite']) {
        if ($_SESSION['userid']) {
            $template_path = $basepath . '/templates/' . $mod['paysite']['paysite_template_members'];
            $template_url = $basehttp . '/templates/' . $mod['paysite']['paysite_template_members'];
        } else {
            $template_path = $basepath . '/templates/' . $mod['paysite']['paysite_template_tour'];
            $template_url = $basehttp . '/templates/' . $mod['paysite']['paysite_template_tour'];
        }
    }
}

include($basepath . "/admin/functions.custom.php"); //custom functions (please put all new functions in here)
include($basepath . "/includes/transliterate.php");
if ($enable_twitter_login) {
    @include($basepath . '/includes/twitter/twitter_init.php');
}
